package cn.com.tenlion.materialstore.service.materialaudio;

import cn.com.tenlion.materialstore.pojo.bos.materialaudio.MaterialAudioBO;
import cn.com.tenlion.materialstore.pojo.dtos.materialaudio.MaterialAudioDTO;
import cn.com.tenlion.materialstore.pojo.pos.materialaudio.MaterialAudioPO;
import cn.com.tenlion.materialstore.pojo.vos.materialaudio.MaterialAudioVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialAudioService
 * @Description: 音频素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 10:41:09
 * @Version: 3.0
 **/
public interface IMaterialAudioService {

    /**
     * 新增音频素材
     *
     * @param materialAudioVO
     * @return
     */
    void save(MaterialAudioVO materialAudioVO);

    /**
     * 新增音频素材
     *
     * @param token
     * @param materialAudioVO
     * @return
     */
    void save(String token, MaterialAudioVO materialAudioVO);

    /**
     * 新增音频素材
     *
     * @param materialAudioVO
     * @return materialAudioId
     */
    String saveReturnId(MaterialAudioVO materialAudioVO);

    /**
     * 新增音频素材
     *
     * @param token
     * @param materialAudioVO
     * @return materialAudioId
     */
    String saveReturnId(String token, MaterialAudioVO materialAudioVO);

    /**
     * 删除音频素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除音频素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除音频素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改音频素材
     *
     * @param materialAudioId
     * @param materialAudioVO
     * @return
     */
    void update(String materialAudioId, MaterialAudioVO materialAudioVO);

    /**
     * 修改音频素材
     *
     * @param token
     * @param materialAudioId
     * @param materialAudioVO
     * @return
     */
    void update(String token, String materialAudioId, MaterialAudioVO materialAudioVO);

    /**
     * 音频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialAudioDTO get(Map<String, Object> params);

    /**
     * 音频素材详情
     *
     * @param materialAudioId
     * @return
     */
    MaterialAudioDTO get(String materialAudioId);

    /**
     * 音频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialAudioBO getBO(Map<String, Object> params);

    /**
     * 音频素材详情
     *
     * @param materialAudioId
     * @return
     */
    MaterialAudioBO getBO(String materialAudioId);

    /**
     * 音频素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialAudioPO getPO(Map<String, Object> params);

    /**
     * 音频素材详情
     *
     * @param materialAudioId
     * @return
     */
    MaterialAudioPO getPO(String materialAudioId);

    /**
     * 音频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialAudioDTO> list(Map<String, Object> params);

    /**
     * 音频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialAudioBO> listBO(Map<String, Object> params);

    /**
     * 音频素材列表
     *
     * @param params
     * @return
     */
    List<MaterialAudioPO> listPO(Map<String, Object> params);

    /**
     * 音频素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialAudioDTO>> listPage(ListPage page);

    /**
     * 音频素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialAudioDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}